#Boa:Frame:Frame1

import wx
from wx.lib.anchors import LayoutAnchors

try:
     from serial.tools.list_ports import comports
except ImportError:
    comports = None

import bv4221
import AT93c46_16
import AT93c46_8
import M24c01
import M24c02
import M24c16


bv4 = bv4221.bv4221()

# Build the device table out of the device name to present to the user followed by
# the import file and class name as shown
DEVICES = {'AT93c46_16': AT93c46_16.at93c46_16(bv4), 'AT93c46_8':AT93c46_8.at93c46_8(bv4),
           'M24c16':M24c16.m24c16(bv4),'M24c01':M24c01.m24c01(bv4),
           'M24c02':M24c02.m24c02(bv4)
          }
           

def create(parent):
    return Frame1(parent)

[wxID_FRAME1, wxID_FRAME1ADDRESS, wxID_FRAME1BOTTOM, wxID_FRAME1CONNECT, 
 wxID_FRAME1DEVICE, wxID_FRAME1I2CADDRESS, wxID_FRAME1PORT, wxID_FRAME1READ, 
 wxID_FRAME1READ_FROM, wxID_FRAME1READ_TO, wxID_FRAME1STATICTEXT1, 
 wxID_FRAME1STATICTEXT2, wxID_FRAME1STATICTEXT3, wxID_FRAME1STATICTEXT4, 
 wxID_FRAME1TEXT, wxID_FRAME1TOP, wxID_FRAME1TYPE, wxID_FRAME1VALUE, 
 wxID_FRAME1WRITE, 
] = [wx.NewId() for _init_ctrls in range(19)]

class Frame1(wx.Frame):
    cdevice = None
    frame_activated = None # so as not to keep filling up comboo boxes
    def _init_ctrls(self, prnt):
        # generated method, don't edit
        wx.Frame.__init__(self, id=wxID_FRAME1, name='Frame1', parent=prnt,
              pos=wx.Point(478, 212), size=wx.Size(394, 352),
              style=wx.DEFAULT_FRAME_STYLE, title='BV4221 - EEPROM')
        self.SetClientSize(wx.Size(386, 325))
        self.SetAutoLayout(True)
        self.Bind(wx.EVT_ACTIVATE, self.OnFrame1Activate)
        self.Bind(wx.EVT_CLOSE, self.OnFrame1Close)

        self.Top = wx.Panel(id=wxID_FRAME1TOP, name='Top', parent=self,
              pos=wx.Point(0, 0), size=wx.Size(386, 32),
              style=wx.TAB_TRAVERSAL)
        self.Top.SetConstraints(LayoutAnchors(self.Top, True, True, True,False))
        self.Top.SetAutoLayout(True)

        self.Bottom = wx.Panel(id=wxID_FRAME1BOTTOM, name='Bottom', parent=self,
              pos=wx.Point(0, 245), size=wx.Size(386, 80),
              style=wx.CLIP_CHILDREN | wx.TAB_TRAVERSAL)
        self.Bottom.SetConstraints(LayoutAnchors(self.Bottom, True, False, True,
              True))
        self.Bottom.SetAutoLayout(True)

        self.text = wx.TextCtrl(id=wxID_FRAME1TEXT, name='text', parent=self,
              pos=wx.Point(0, 31), size=wx.Size(388, 214),
              style=wx.TE_MULTILINE,
              value='1) connect, 2) select device 3) read, 4) write')
        self.text.SetConstraints(LayoutAnchors(self.text, True, True, True,
              True))
        self.text.SetAutoLayout(True)
        self.text.SetFont(wx.Font(8, wx.SWISS, wx.NORMAL, wx.NORMAL, False,
              'Courier New'))

        self.connect = wx.Button(id=wxID_FRAME1CONNECT, label='Connect',
              name='connect', parent=self.Top, pos=wx.Point(108, 3),
              size=wx.Size(75, 23), style=0)
        self.connect.Bind(wx.EVT_BUTTON, self.OnConnectButton,
              id=wxID_FRAME1CONNECT)

        self.port = wx.ComboBox(choices=[], id=wxID_FRAME1PORT, name='port',
              parent=self.Top, pos=wx.Point(4, 4), size=wx.Size(96, 21),
              style=0, value='<port>')
        self.port.SetLabel('<port>')

        self.read = wx.Button(id=wxID_FRAME1READ, label='Read', name='read',
              parent=self.Bottom, pos=wx.Point(13, 4), size=wx.Size(75, 24),
              style=wx.ALWAYS_SHOW_SB)
        self.read.SetConstraints(LayoutAnchors(self.read, True, False, False,
              False))
        self.read.SetAutoLayout(False)
        self.read.Enable(False)
        self.read.Bind(wx.EVT_BUTTON, self.OnReadButton, id=wxID_FRAME1READ)

        self.write = wx.Button(id=wxID_FRAME1WRITE, label='Write', name='write',
              parent=self.Bottom, pos=wx.Point(14, 37), size=wx.Size(72, 23),
              style=0)
        self.write.SetAutoLayout(False)
        self.write.SetConstraints(LayoutAnchors(self.write, True, False, False,
              False))
        self.write.Enable(False)
        self.write.Bind(wx.EVT_BUTTON, self.OnWriteButton, id=wxID_FRAME1WRITE)

        self.address = wx.ComboBox(choices=[], id=wxID_FRAME1ADDRESS,
              name='address', parent=self.Bottom, pos=wx.Point(96, 39),
              size=wx.Size(93, 21), style=0, value='')
        self.address.SetLabel('')

        self.value = wx.TextCtrl(id=wxID_FRAME1VALUE, name='value',
              parent=self.Bottom, pos=wx.Point(201, 40), size=wx.Size(100, 21),
              style=0, value='0')

        self.staticText1 = wx.StaticText(id=wxID_FRAME1STATICTEXT1,
              label='Value in Hex', name='staticText1', parent=self.Bottom,
              pos=wx.Point(205, 64), size=wx.Size(60, 13), style=0)

        self.device = wx.ComboBox(choices=[], id=wxID_FRAME1DEVICE,
              name='device', parent=self.Top, pos=wx.Point(198, 5),
              size=wx.Size(130, 21), style=0, value='<select device>')
        self.device.SetLabel('<select device>')
        self.device.Enable(False)
        self.device.Bind(wx.EVT_COMBOBOX, self.OnDeviceCombobox,
              id=wxID_FRAME1DEVICE)

        self.staticText2 = wx.StaticText(id=wxID_FRAME1STATICTEXT2,
              label='Address', name='staticText2', parent=self.Bottom,
              pos=wx.Point(104, 64), size=wx.Size(40, 11), style=0)

        self.type = wx.StaticText(id=wxID_FRAME1TYPE, label='T', name='type',
              parent=self.Top, pos=wx.Point(335, 9), size=wx.Size(8, 13),
              style=0)

        self.i2caddress = wx.StaticText(id=wxID_FRAME1I2CADDRESS, label='A',
              name='i2caddress', parent=self.Top, pos=wx.Point(356, 9),
              size=wx.Size(8, 13), style=0)

        self.read_from = wx.TextCtrl(id=wxID_FRAME1READ_FROM, name='read_from',
              parent=self.Bottom, pos=wx.Point(135, 6), size=wx.Size(60, 21),
              style=0, value='0')

        self.staticText3 = wx.StaticText(id=wxID_FRAME1STATICTEXT3,
              label='From', name='staticText3', parent=self.Bottom,
              pos=wx.Point(102, 10), size=wx.Size(24, 13), style=0)

        self.staticText4 = wx.StaticText(id=wxID_FRAME1STATICTEXT4, label='To',
              name='staticText4', parent=self.Bottom, pos=wx.Point(204, 9),
              size=wx.Size(16, 13), style=0)

        self.read_to = wx.TextCtrl(id=wxID_FRAME1READ_TO, name='read_to',
              parent=self.Bottom, pos=wx.Point(226, 6), size=wx.Size(66, 21),
              style=0, value='0')

    def __init__(self, parent):
        self._init_ctrls(parent)

    def OnFrame1Activate(self, event):
        if self.frame_activated == None:
            self.frame_activated = 1
            if comports:
                for port, desc, hwid in sorted(comports()):
                    self.port.Append(port)
                self.port.SetSelection(0)
            # devices
            for n, device in enumerate(DEVICES):
                self.device.Append(device)

    def OnFrame1Close(self, event):
        #bv4.Close()
        event.Skip()

    def OnConnectButton(self, event):
        cport = self.port.GetValue()
        self.text.Clear()
        self.text.AppendText("Connecting to BV4221 using "+cport)
        self.text.AppendText("\nWait...")
        if bv4.Init(cport,115200) == 1:
            self.text.AppendText("\nWait...")
            if bv4.Init(cport,115200) == 1:
                self.text.AppendText("\n *** Failed to initialise BV4221 ****")
            else:
                self.text.AppendText("\nSucess") 
        else:
            self.text.AppendText("\nSucess")
        # enable device comboo for next step
        if bv4.connected != 0:
             self.device.Enable(True)

    def OnReadButton(self, event):
        if self.cdevice.configured != 1:
            self.text.AppendText("\nDevice ahd dicsonnected")
        else:
            # display on text box
            address = int(self.read_from.GetValue())
            bitsize = self.cdevice.get_bit_size()
            size = int(self.read_to.GetValue())-address
            if bitsize == 16: 
                size/=2
            rows = (size / 8)+1
            self.text.AppendText("\n\nBit size %d " % bitsize)
            self.text.AppendText(" EEPROM size bytes %d " % self.cdevice.get_bytes())
            if bitsize == 16:
                self.text.AppendText("\nAdr    0    1    2    3    4    5    6    7\n")
            else:
                self.text.AppendText("\nAdr   0  1  2  3  4  5  6  7\n")
            for row in range(0,rows):
                self.text.AppendText("%04d" % address)
                for col in range(0,8):
                    if bitsize == 16:
                        self.text.AppendText(" %04x" % int(self.cdevice.read(address),16))
                    else:    
                        self.text.AppendText(" %02x" % int(self.cdevice.read(address),16))
                    address+=1
                self.text.AppendText("\n")
            # add addresses to combo box
            self.address.Clear()
            lastAdr = int(self.read_to.GetValue())
            if bitsize == 16: lastAdr/=2
            #print "from=%d" % int(self.read_from.GetValue())
            #print "to=%d" % int(self.read_to.GetValue())
            for j in range(int(self.read_from.GetValue()),lastAdr+1):
                self.address.Append(str(j))
            # enable write
            self.write.Enable(True)

    def OnWriteButton(self, event):
        adr = int(self.address.GetValue())
        value = int(self.value.GetValue(),16)
        #print adr,value
        self.cdevice.write(adr,value)
        # inform user
        self.text.AppendText("\n"+hex(value)+" written to address "+str(adr))

    def OnDeviceCombobox(self, event):
        d = self.device.GetValue()
        self.cdevice = DEVICES[d]
        self.cdevice.config() # configure the device first
        if self.cdevice.configured == 1:
            # set type lablel
            if self.cdevice.get_type() == 1:
                self.type.SetLabel("SPI")
            if self.cdevice.get_type() == 2:
                self.type.SetLabel("I2C")
                self.i2caddress.SetLabel(self.cdevice.adr)
            # now allow read button
            self.read.Enable(True)
            self.read_to.SetValue(str(self.cdevice.get_bytes()))
            # display notes
            self.text.SetValue("\n")
            self.text.SetValue(self.cdevice.get_notes())
        else:
            self.text.AppendText("\nUnable to configure selected device")
